
#include <stdio.h>
#include <unistd.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>
#include "xpadtrans.h"

char conf_file[1024];

void calc_geom(const char *st, int *x_r, int *y_r, int *w_r, int *h_r)
{
    char buffer[256];
    char *t, *s;
    if (strlen(st) > 254) return;
    strcpy(buffer, st);
    t = strrchr(buffer, '+');
    s = strchr(buffer, '+');
    if ((s) && (t) && (s != t)){
        *y_r = atoi(t);
        *t = 0;
        *x_r = atoi(s);
        *s = 0;
    }
    t = strchr(buffer, 'x');
    if ((t) && (strlen(t) > 1)){
        *h_r = atoi(t+1);
        *t = 0;
        *w_r = atoi(buffer);
    }
}

int main(int argc, char **argv)
{
    int i, posx = -1, posy = -1;
    int w = -1, h = -1;
    int iconic = 0;
    char paddev[1024] = "/dev/pad00";
    int padtype = 0;
    
    sprintf(conf_file, "%s/%s", getenv("HOME"), ".xpadtrans");
    for (i=1; i<argc; i++){
        if (!strcmp(argv[i], "-geometry")){
            if (++i < argc)
                calc_geom(argv[i], &posx, &posy, &w, &h);
        }
        if (!strcmp(argv[i], "-iconic")){
            iconic = 1;
        }
        if (!strcmp(argv[i], "-config")){
            if (++i < argc)
                strcpy(conf_file, argv[i]);
        }
        if (!strcmp(argv[i], "-pad")){
            if (++i < argc)
                strcpy(paddev, argv[i]);
        }
        if (!strcmp(argv[i], "-2button")){
            padtype = 0;
        }
        if (!strcmp(argv[i], "-6button")){
            padtype = 1;
        }
        if (!strcmp(argv[i], "-ajoy")){
            padtype = 2;
        }
    }
    if (open_window(posx, posy, w, h, iconic, paddev, padtype))
        return -1;
    if (keydef_list_load(conf_file)){
        fprintf(stderr, "failed to load (%s).\n", conf_file);
        return -1;
    }
    while(!main_loop());
    return 0;
}
